global function OnProjectileCollision_weapon_grenade_emp

void function OnProjectileCollision_weapon_grenade_emp( entity projectile, vector pos, vector normal, entity hitEnt, int hitbox, bool isCritical )
{
	entity player = projectile.GetOwner()
	if ( hitEnt == player )
		return

	table collisionParams =
	{
		pos = pos,
		normal = normal,
		hitEnt = hitEnt,
		hitbox = hitbox
	}

	/*
	if ( IsSingleplayer() && ( player && !player.IsPlayer() ) )
		collisionParams.hitEnt = GetEntByIndex( 0 )

	bool result = PlantStickyEntity( projectile, collisionParams )

	if ( projectile.GrenadeHasIgnited() )
		return

	//Triggering this on the client triggers an impact effect.
	#if SERVER
	projectile.GrenadeIgnite()
	#endif
	*/
	
	#if SERVER
	vector angle = projectile.GetAngles()
	//vector pnormal = projectile.GetNormal()
	//printt( pnormal )
	angle = VectorToAngles(projectile.GetVelocity())
	//printt( angle )
	angle.z = 0
	angle.x = 0
	
	create_emp_decoy( player, pos, angle )
	projectile.Destroy()
	#endif
	
}

#if SERVER
void function create_emp_decoy( entity player, vector pos, vector angle )
{
	float stickPercentToRun = 0.3 // default is 0.65, we want to be more lenient. walking is usually obvious bc normal people bhop everywhere
	entity decoy = player.CreatePlayerDecoy( stickPercentToRun )
	decoy.SetMaxHealth( 50 )
	decoy.SetHealth( 50 )
	//decoy.EnableAttackableByAI( 50, 0, AI_AP_FLAG_NONE )
	SetObjectCanBeMeleed( decoy, true )
	float decoy_time = 5.0
	decoy.SetTimeout( decoy_time )

	SetupDecoy_Common( player, decoy )
	
	decoy.SetScriptName( "emp_decoy" )
	// decoys are level to the ground, grenades arent
	
	//printt( angle )
	
	decoy.SetOrigin( pos )
	decoy.SetAngles( angle )
	decoy.SetVelocity( < 0, 0, 0 > )
	
	//decoy.SetFriendlyFire( true ) // allow friendly fire for testing

	thread threaded_emp_decoy( decoy, player )
}

void function threaded_emp_decoy( entity decoy, entity player )
{
	AddEntityCallback_OnKilled( decoy, emp_decoy_attacker )
	while ( IsAlive( decoy ) && IsValid( decoy ) )
	{
		WaitFrame()
	}
	//RemoveEntityCallback_OnKilled( decoy, threaded_emp_decoy_attacker )
}

void function emp_decoy_attacker( entity victim, var damageInfo )
{
	if ( victim.GetScriptName() != "emp_decoy" ) // dont trigger for regular holopilot
		return
	entity attacker = DamageInfo_GetAttacker( damageInfo )
	if ( !IsValid( attacker ) || !attacker.IsPlayer  || !IsAlive( attacker ) )
		return
	thread threaded_emp_decoy_attacker( victim, attacker )
}

void function threaded_emp_decoy_attacker ( entity victim, entity attacker )
{
	float flash_fade_in_duration = 0.2
	float flash_max_duration = 1.0
	float flash_fade_out_duration = 2.0
	float extra_highlight_duration = 5.0
	
	if ( !attacker.IsPlayer() || !IsValid( attacker ) )
		return
	
	if ( !IsValid( attacker ) || !IsAlive( attacker ) )
		return
	//EmitSoundOnEntity( attacker, "UI_InGame_MarkedForDeath_PlayerMarked" )
	StatusEffect_AddTimed( attacker, eStatusEffect.maphack_detected, 1.0, flash_fade_in_duration + flash_max_duration + flash_fade_out_duration + extra_highlight_duration, 0.0 )
	EmitSoundOnEntityOnlyToPlayer( attacker, attacker, "HUD_MP_BountyHunt_BankBonusPts_Deposit_End_Unsuccessful_1P" )
	EmitSoundOnEntityExceptToPlayer( attacker, attacker, "HUD_MP_BountyHunt_BankBonusPts_Deposit_End_Unsuccessful_3P" )
	Highlight_SetEnemyHighlight( attacker, "enemy_boss_bounty" )
	
	if ( !IsValid( attacker ) )
		return
	ScreenFade( attacker, 0, 0, 0, 255, flash_fade_in_duration, flash_max_duration, FFADE_OUT  )
	wait( flash_fade_in_duration )
	
	
	if ( !IsValid( attacker ) )
		return
	ScreenFade( attacker, 0, 0, 0, 255, flash_fade_out_duration, flash_max_duration, FFADE_IN  )
	wait( flash_max_duration + flash_fade_out_duration )
	wait( extra_highlight_duration )
	
	if ( !IsValid( attacker ) )
		return
	Highlight_ClearEnemyHighlight( attacker )
}

/*
global function emp_decoy_init

void function emp_decoy_init()
{
	AddDeathCallback( 
}
*/
#endif // #if SERVER